// project created on 22.05.2004 at 13:06
//Based on classes from http://www.thecodeproject.com/csharp/globalhook.asp?print=true
//By George Mamaladze  
//Main form written to control mouse with keyboard
//By Tim Wylie
using System;
using System.Drawing;
using System.Windows.Forms;
using System.Runtime.InteropServices;

namespace GlobalHookDemo 
{
	class MainForm : System.Windows.Forms.Form
	{
		//imports mouse_event function from user32.dll
		[DllImport("user32.dll",CharSet=CharSet.Auto, CallingConvention=CallingConvention.StdCall)]
		public static extern void mouse_event(long dwFlags, long dx, long dy, long cButtons, long dwExtraInfo);
		//declare consts for mouse messages
		public const int MOUSEEVENTF_LEFTDOWN = 0x02;
		public const int MOUSEEVENTF_LEFTUP = 0x04;
		public const int MOUSEEVENTF_RIGHTDOWN = 0x08;
		public const int MOUSEEVENTF_RIGHTUP = 0x10;

		private System.Windows.Forms.Button buttonStart;
		private System.Windows.Forms.Button buttonStop;
		private System.Windows.Forms.Label labelMousePosition;
		private System.Windows.Forms.TextBox textBox;
		private int xDist;
		private int yDist;
		private int xSmDist;
		private int ySmDist;
		private System.Windows.Forms.Button buttonLog;
		private bool AltDown = false;
		private bool CtlDown = false;
		private bool WinDown = false;
		private bool Log = false;
		public MainForm()
		{
			InitializeComponent();
			xDist=Convert.ToInt32(System.Windows.Forms.Screen.PrimaryScreen.Bounds.Width*.1);
			yDist=Convert.ToInt32(System.Windows.Forms.Screen.PrimaryScreen.Bounds.Height*.1);
			xSmDist=Convert.ToInt32(System.Windows.Forms.Screen.PrimaryScreen.Bounds.Width*.01);
			ySmDist=Convert.ToInt32(System.Windows.Forms.Screen.PrimaryScreen.Bounds.Height*.01);
			
			labelMousePosition.Text ="";
		}
	
		// THIS METHOD IS MAINTAINED BY THE FORM DESIGNER
		// DO NOT EDIT IT MANUALLY! YOUR CHANGES ARE LIKELY TO BE LOST
		void InitializeComponent() {
			this.textBox = new System.Windows.Forms.TextBox();
			this.labelMousePosition = new System.Windows.Forms.Label();
			this.buttonStop = new System.Windows.Forms.Button();
			this.buttonStart = new System.Windows.Forms.Button();
			this.buttonLog = new System.Windows.Forms.Button();
			this.SuspendLayout();
			// 
			// textBox
			// 
			this.textBox.Font = new System.Drawing.Font("Courier New", 11F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.World);
			this.textBox.Location = new System.Drawing.Point(3, 48);
			this.textBox.Multiline = true;
			this.textBox.Name = "textBox";
			this.textBox.ScrollBars = System.Windows.Forms.ScrollBars.Vertical;
			this.textBox.Size = new System.Drawing.Size(188, 72);
			this.textBox.TabIndex = 3;
			this.textBox.Text = "";
			// 
			// labelMousePosition
			// 
			this.labelMousePosition.Location = new System.Drawing.Point(8, 28);
			this.labelMousePosition.Name = "labelMousePosition";
			this.labelMousePosition.Size = new System.Drawing.Size(112, 20);
			this.labelMousePosition.TabIndex = 2;
			this.labelMousePosition.Text = "labelMousePosition";
			// 
			// buttonStop
			// 
			this.buttonStop.Location = new System.Drawing.Point(74, 1);
			this.buttonStop.Name = "buttonStop";
			this.buttonStop.Size = new System.Drawing.Size(46, 23);
			this.buttonStop.TabIndex = 1;
			this.buttonStop.Text = "Stop";
			this.buttonStop.Click += new System.EventHandler(this.ButtonStopClick);
			// 
			// buttonStart
			// 
			this.buttonStart.Location = new System.Drawing.Point(3, 2);
			this.buttonStart.Name = "buttonStart";
			this.buttonStart.Size = new System.Drawing.Size(46, 23);
			this.buttonStart.TabIndex = 0;
			this.buttonStart.Text = "Start";
			this.buttonStart.Click += new System.EventHandler(this.ButtonStartClick);
			// 
			// buttonLog
			// 
			this.buttonLog.Location = new System.Drawing.Point(144, 2);
			this.buttonLog.Name = "buttonLog";
			this.buttonLog.Size = new System.Drawing.Size(46, 23);
			this.buttonLog.TabIndex = 4;
			this.buttonLog.Text = "Log";
			this.buttonLog.Click += new System.EventHandler(this.buttonLog_Click);
			// 
			// MainForm
			// 
			this.AutoScaleBaseSize = new System.Drawing.Size(5, 13);
			this.ClientSize = new System.Drawing.Size(192, 126);
			this.Controls.Add(this.buttonLog);
			this.Controls.Add(this.textBox);
			this.Controls.Add(this.labelMousePosition);
			this.Controls.Add(this.buttonStop);
			this.Controls.Add(this.buttonStart);
			this.Name = "MainForm";
			this.Text = "KeyMouse";
			this.Load += new System.EventHandler(this.MainFormLoad);
			this.ResumeLayout(false);

		}
			
		[STAThread]
		public static void Main(string[] args)
		{
			Application.Run(new MainForm());
		}
		
		void ButtonStartClick(object sender, System.EventArgs e)
		{
			actHook.Start();
		}
		
		void ButtonStopClick(object sender, System.EventArgs e)
		{
			actHook.Stop();
		}
		
		
		UserActivityHook actHook;
		void MainFormLoad(object sender, System.EventArgs e)
		{
			actHook= new UserActivityHook(); // crate an instance
			// hang on events
			actHook.OnMouseActivity+=new MouseEventHandler(MouseMoved);
			actHook.KeyDown+=new KeyEventHandler(MyKeyDown);
			actHook.KeyPress+=new KeyPressEventHandler(MyKeyPress);
			actHook.KeyUp+=new KeyEventHandler(MyKeyUp);
		}
		
		public void MouseMoved(object sender, MouseEventArgs e)
		{
			if(Log)
			{
				labelMousePosition.Text=String.Format("x={0}  y={1}", e.X, e.Y);
				if (e.Clicks>0) LogWrite("MouseButton-" + e.Button.ToString());
			}
		}
		
		public void MyKeyDown(object sender, KeyEventArgs e)
		{
			if(Log)
				LogWrite("KeyDown-" + e.KeyData.ToString());

			if(e.KeyCode==Keys.LMenu||e.KeyCode==Keys.RMenu)
			{
				AltDown=true;
			}		
			if(e.KeyCode==Keys.LControlKey||e.KeyCode==Keys.RControlKey)
			{
				CtlDown=true;
			}	
			if(e.KeyCode==Keys.LWin||e.KeyCode==Keys.RWin)
			{
				WinDown=true;
			}	
			if(AltDown && CtlDown)
			{
				if(WinDown)
				{
					if(e.KeyCode==Keys.Up)
						Cursor.Position = new Point(Cursor.Position.X, Cursor.Position.Y-ySmDist);
					if(e.KeyCode==Keys.Down)
						Cursor.Position = new Point(Cursor.Position.X, Cursor.Position.Y+ySmDist);
					if(e.KeyCode==Keys.Right)
						Cursor.Position = new Point(Cursor.Position.X+xSmDist, Cursor.Position.Y);
					if(e.KeyCode==Keys.Left)
						Cursor.Position = new Point(Cursor.Position.X-xSmDist, Cursor.Position.Y);
				}
				else
				{
					if(e.KeyCode==Keys.Up)
						Cursor.Position = new Point(Cursor.Position.X, Cursor.Position.Y-yDist);
					if(e.KeyCode==Keys.Down)
						Cursor.Position = new Point(Cursor.Position.X, Cursor.Position.Y+yDist);
					if(e.KeyCode==Keys.Right)
						Cursor.Position = new Point(Cursor.Position.X+xDist, Cursor.Position.Y);
					if(e.KeyCode==Keys.Left)
						Cursor.Position = new Point(Cursor.Position.X-xDist, Cursor.Position.Y);
				}
				if(e.KeyCode==Keys.Enter)
				{
					//and click
					mouse_event(MOUSEEVENTF_LEFTDOWN, 0, 0, 0, 0);
					mouse_event(MOUSEEVENTF_LEFTUP, 0, 0, 0, 0);
				}
				if(e.KeyCode==Keys.NumPad0)
				{
					//and click
					mouse_event(MOUSEEVENTF_RIGHTDOWN, 0, 0, 0, 0);
					mouse_event(MOUSEEVENTF_RIGHTUP, 0, 0, 0, 0);
				}
			}	
		}
		
		public void MyKeyPress(object sender, KeyPressEventArgs e)
		{
			if(Log)
				LogWrite("KeyPress-" + e.KeyChar);	
		}
		
		public void MyKeyUp(object sender, KeyEventArgs e)
		{
			if(Log)
				LogWrite("KeyUp-" + e.KeyData.ToString());

			if(e.KeyCode == Keys.LMenu||e.KeyCode==Keys.RMenu)
				AltDown=false;
			if(e.KeyCode==Keys.LControlKey||e.KeyCode==Keys.RControlKey)
				CtlDown=false;
			if(e.KeyCode==Keys.LWin||e.KeyCode==Keys.RWin)
				WinDown=false;
		}
		
		private void LogWrite(string txt)
		{
			textBox.AppendText(txt + Environment.NewLine);
			textBox.SelectionStart = textBox.Text.Length;
		}

		private void buttonLog_Click(object sender, System.EventArgs e)
		{
			if(Log)
				Log=false;
			else
				Log=true;
		}

	}			
}
